"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = connectSource;

require("core-js/modules/es7.symbol.async-iterator");

require("core-js/modules/es6.symbol");

require("core-js/modules/web.dom.iterable");

var _reselect = require("reselect");

var _reactRedux = require("react-redux");

var _reactCommonKit = require("react-common-kit");

var _reduxSourceUtils = require("redux-source-utils");

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function connectSource(_ref, _ref2) {
  var stateName = _ref.stateName,
      denormalize = _ref.denormalize,
      actions = _ref.actions;
  var slice = _ref2.slice,
      actionsProp = _ref2.actionsProp,
      _ref2$enableErrorLogg = _ref2.enableErrorLogger,
      enableErrorLogger = _ref2$enableErrorLogg === void 0 ? false : _ref2$enableErrorLogg;

  var mapStateToProps = function mapStateToProps(oldState) {
    var newState = (0, _reduxSourceUtils.unwrap)(oldState);

    for (var _len = arguments.length, other = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      other[_key - 1] = arguments[_key];
    }

    return (0, _reselect.createSelector)([function (state) {
      return slice(state).getIn([stateName, 'result']);
    }, function (state) {
      return slice(state).getIn([stateName, 'entities']);
    }, function (state) {
      return slice(state).getIn([stateName, 'errors']);
    }, function (state) {
      return slice(state).getIn([stateName, 'isPending']);
    }, function (state) {
      return slice(state).getIn([stateName, 'inited']);
    }],
    /* eslint-disable max-params */
    function (result, entities, errors, isPending, inited) {
      var res = denormalize(result.toJS(), entities.toJS()); // console.log(
      //   'denormalize',
      //   { result: result.toJS(), entities: entities.toJS() },
      //   res,
      // );

      var errorList = errors.toJS();

      if (errors.length && enableErrorLogger && (typeof console === "undefined" ? "undefined" : _typeof(console)) === 'object' && console.error) {
        errorList.forEach(function (error) {
          console.error("".concat(stateName, " error:"), error.stack || error);
        });
      }

      return _defineProperty({}, stateName, {
        result: res,
        errors: errorList,
        isPending: isPending,
        inited: inited
      });
    }
    /* eslint-enable max-params */
    ).apply(void 0, [newState].concat(other));
  };

  var mapDispatchToProps = function mapDispatchToProps(dispatch) {
    return actionsProp ? _defineProperty({}, actionsProp, (0, _reduxSourceUtils.bindActionCreators)(actions, dispatch)) : {};
  };

  var result = (0, _reactCommonKit.createHoc)(function (WrappedComponent) {
    return (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(WrappedComponent);
  }, {
    name: 'ConnectSource'
  });
  result.mapStateToProps = mapStateToProps;
  return result;
}

module.exports = exports["default"];